DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Speech To Text

The DevExtreme JavaScript SpeechToText component allows you to integrate voice input into your DevExtreme-powered app. The component implements the Web Speech API SpeechRecognition interface and supports custom speech recognizers.

Backend API
$(() => { const shouldUpdateType = () => displayMode.option('value') === 'Custom'; let state = 'initial'; const speechToText = $('#speech-to-text') .dxSpeechToText({ type: 'default', hint: 'Start voice recognition', speechRecognitionConfig: { interimResults: true, continuous: false, }, onStartClick: ({ component }) => { if (!window.SpeechRecognition && !window.webkitSpeechRecognition) { DevExpress.ui.notify({ message: 'The browser does not support Web Speech API (SpeechRecognition).', type: 'error', displayTime: 7000, position: 'bottom center', width: 'auto', }); return; } state = 'listening'; component.option('hint', 'Stop voice recognition'); if (!shouldUpdateType()) { return; } type.option('value', 'Danger'); }, onEnd: ({ component }) => { state = 'initial'; component.option('hint', 'Start voice recognition'); if (!shouldUpdateType()) { return; } type.option('value', 'Default'); }, onResult: ({ event }) => { const { results } = event; const resultText = Object.values(results) .map((resultItem) => resultItem[0].transcript.trim()) .join(' '); textArea.option('value', resultText); }, }) .dxSpeechToText('instance'); const textArea = $('#text-area') .dxTextArea({ width: 360, height: 120, placeholder: 'Recognized text will appear here...', inputAttr: { 'aria-label': 'Recognized Text' }, onValueChanged: ({ value }) => { clearButton.option('disabled', !value); }, }) .dxTextArea('instance'); const clearButton = $('#clear-button') .dxButton({ text: 'Clear', disabled: true, onClick: () => { textArea.option('value', ''); }, }) .dxButton('instance'); const displayMode = $('#display-mode') .dxSelectBox({ items: ['Icon Only', 'Text and Icon', 'Custom'], value: 'Icon Only', inputAttr: { 'aria-label': 'Display Mode' }, onValueChanged: ({ value }) => { const $speechToText = speechToText.$element(); const isCustomMode = value === 'Custom'; stylingMode.option('disabled', isCustomMode); type.option('disabled', isCustomMode); $speechToText.removeClass('custom-button'); if (value === 'Text and Icon') { speechToText.option({ startText: 'Dictate', stopText: 'Stop', }); return; } speechToText.option({ startText: '', stopText: '' }); if (isCustomMode) { stylingMode.option('value', 'Contained'); type.option('value', state === 'initial' ? 'Default' : 'Danger'); $speechToText.addClass('custom-button'); } }, }) .dxSelectBox('instance'); const stylingMode = $('#styling-mode') .dxSelectBox({ items: ['Contained', 'Outlined', 'Text'], value: 'Contained', inputAttr: { 'aria-label': 'Styling Mode' }, onValueChanged: ({ value }) => { speechToText.option('stylingMode', value.toLowerCase()); }, }) .dxSelectBox('instance'); const type = $('#type') .dxSelectBox({ items: ['Normal', 'Success', 'Default', 'Danger'], value: 'Default', inputAttr: { 'aria-label': 'Type' }, onValueChanged: ({ value }) => { speechToText.option('type', value.toLowerCase()); }, }) .dxSelectBox('instance'); $('#disabled').dxSwitch({ onValueChanged: ({ value }) => { speechToText.option('disabled', value); }, }); $('#language').dxSelectBox({ items: ['Auto-detect', 'English', 'Spanish', 'French', 'German'], value: 'Auto-detect', inputAttr: { 'aria-label': 'Language' }, onValueChanged: ({ value }) => { speechToText.option('speechRecognitionConfig.lang', langMap[value]); }, }); $('#interim-results').dxSwitch({ value: true, onValueChanged: ({ value }) => { speechToText.option('speechRecognitionConfig.interimResults', value); }, }); $('#continuous-recognition').dxSwitch({ onValueChanged: ({ value }) => { speechToText.option('speechRecognitionConfig.continuous', value); }, }); $('#animation').dxSwitch({ value: true, onValueChanged: ({ value }) => { speechToText.$element().toggleClass('animation-disabled', !value); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="data.js"></script> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="speech-to-text-container"> <span>Use voice recognition (speech to text)</span> <div id="speech-to-text"></div> <div id="text-area"></div> <div id="clear-button"></div> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <div>Display Mode</div> <div id="display-mode"></div> </div> <div class="option"> <div>Styling Mode</div> <div id="styling-mode"></div> </div> <div class="option"> <div>Type</div> <div id="type"></div> </div> <div class="switch"> <div id="disabled"></div> <span>Disabled</span> </div> <div class="option-separator"></div> <div class="option"> <div>Language</div> <div id="language"></div> </div> <div class="switch"> <div id="interim-results"></div> <span>Interim Results</span> </div> <div class="switch"> <div id="continuous-recognition"></div> <span>Continuous Recognition</span> </div> <div class="option-separator"></div> <div class="switch"> <div id="animation"></div> <span>Animation</span> </div> </div> </div> </body> </html>
.demo-container { display: flex; gap: 20px; height: 640px; } .speech-to-text-container { display: flex; flex-direction: column; row-gap: 16px; flex-grow: 1; align-items: center; justify-content: center; } #text-area { margin-top: 16px; } .options { display: flex; flex-direction: column; flex-shrink: 0; width: 300px; box-sizing: border-box; padding: 20px; background-color: rgba(191, 191, 191, 0.15); gap: 16px; } .caption { font-weight: 500; font-size: 18px; } .option { display: flex; flex-direction: column; row-gap: 4px; } .switch { display: flex; align-items: center; column-gap: 8px; } .option-separator { border-bottom: 1px solid var(--dx-color-border); } #speech-to-text.animation-disabled { animation: none; } #speech-to-text.custom-button { border-radius: 2rem; }
const langMap = { "Auto-detect": '', "English": 'en-US', "Spanish": 'es-ES', "French": 'fr-FR', "German": 'de-DE', };

You can integrate JavaScript SpeechToText with any text input, including editors available in the DevExtreme product line. Simply set a component's value property to transcribed text. JavaScript SpeechToText returns transcribed text in the onResult handler as a user speaks. When speech stops, the component calls the onEnd handler and switches from a "listening" state to the initial state. JavaScript SpeechToText implements state-dependent icons (startIcon/stopIcon), text (startText/stopText), and click handlers (onStartClick/onStopClick).

For a complete overview of JavaScript SpeechToText options (including Web Speech API options), refer to the following topic: JavaScript SpeechToText API Reference.

<template>
<div className="speech-to-text-demo">
<div class="speech-to-text-container">
<span>Use voice recognition (speech to text)</span>
<DxSpeechToText
id="speech-to-text"
:class="{ 'animation-disabled': !animation, 'custom-button': displayMode === 'Custom' }"
:start-text="startText"
:stop-text="stopText"
v-model:type="type"
v-model:styling-mode="stylingMode"
:hint="hint"
:speech-recognition-config="speechRecognitionConfig"
v-model:disabled="disabled"
@start-click="onStartClick"
@stop-click="onStopClick"
@result="onResult"
/>
<DxTextArea
id="text-area"
v-model:value="textAreaValue"
:width="360"
:height="120"
placeholder="Recognized text will appear here..."
:input-attr="{ 'aria-label': 'Recognized Text' }"
/>
<DxButton
text="Clear"
:disabled="textAreaValue === ''"
@click="onClearButtonClick"
/>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div>Display Mode</div>
<DxSelectBox
v-model:value="displayMode"
:data-source="displayModes"
:input-attr="{ 'aria-label': 'Display Mode' }"
@value-changed="onDisplayModeChanged"
/>
</div>
<div class="option">
<div>Styling Mode</div>
<DxSelectBox
v-model="stylingMode"
:data-source="stylingModes"
display-expr="displayValue"
value-expr="value"
:disabled="displayMode === 'Custom'"
:input-attr="{ 'aria-label': 'Styling Mode' }"
/>
</div>
<div class="option">
<div>Type</div>
<DxSelectBox
v-model="type"
:data-source="types"
display-expr="displayValue"
value-expr="value"
:disabled="displayMode === 'Custom'"
:input-attr="{ 'aria-label': 'Type' }"
/>
</div>
<div class="switch">
<DxSwitch
v-model="disabled"
/>
<span>Disabled</span>
</div>
<div class="option-separator"/>
<div class="option">
<div>Language</div>
<DxSelectBox
v-model="language"
:data-source="languages"
:input-attr="{ 'aria-label': 'Language' }"
/>
</div>
<div class="switch">
<DxSwitch
v-model="interimResults"
/>
<span>Interim Results</span>
</div>
<div class="switch">
<DxSwitch
v-model="continuous"
/>
<span>Continuous Recognition</span>
</div>
<div class="option-separator"/>
<div class="switch">
<DxSwitch
v-model="animation"
/>
<span>Animation</span>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { computed, ref } from 'vue';
import { DxSpeechToText } from 'devextreme-vue/speech-to-text';
import { DxTextArea } from 'devextreme-vue/text-area';
import { DxButton, type DxButtonTypes } from 'devextreme-vue/button';
import { DxSelectBox } from 'devextreme-vue/select-box';
import { DxSwitch } from 'devextreme-vue/switch';
import notify from 'devextreme/ui/notify';
import { displayModes, stylingModes, types, languages, langMap } from './data.ts';
declare global {
interface Window {
SpeechRecognition?: any;
webkitSpeechRecognition?: any;
}
}
let state = 'initial';
const startText = ref('');
const stopText = ref('');
const displayMode = ref(displayModes[0]);
const stylingMode = ref<DxButtonTypes.ButtonStyle>('contained');
const type = ref<DxButtonTypes.ButtonType>('default');
const hint = ref('Start voice recognition');
const disabled = ref(false);
const textAreaValue = ref('');
const language = ref<string>(languages[0]);
const interimResults = ref(true);
const continuous = ref(false);
const animation = ref(true);
const speechRecognitionConfig: Record<string, any> = computed(() => ({
interimResults: interimResults.value,
continuous: continuous.value,
lang: langMap[language.value],
}));
function onStartClick() {
if (!window.SpeechRecognition && !window.webkitSpeechRecognition) {
notify({
message: 'The browser does not support Web Speech API (SpeechRecognition).',
type: 'error',
displayTime: 7000,
position: 'bottom center',
width: 'auto',
});
return;
}
state = 'listening';
hint.value = 'Stop voice recognition';
if (displayMode.value !== 'Custom') {
return;
}
type.value = 'danger';
}
function onStopClick() {
stopHandler();
}
function onResult({ event }: Record<string, any>) {
const { results } = event;
const resultText = Object.values(results)
.map((resultItem: any) => resultItem[0].transcript.trim())
.join(' ');
textAreaValue.value = resultText;
if (!continuous.value && results[0].isFinal === true) {
stopHandler();
}
}
function stopHandler() {
state = 'initial';
hint.value = 'Start voice recognition';
if (displayMode.value !== 'Custom') {
return;
}
type.value = 'default';
}
function onClearButtonClick() {
textAreaValue.value = '';
}
function onDisplayModeChanged({ value }: { value?: string }) {
if (value === 'Text and Icon') {
startText.value = 'Dictate';
stopText.value = 'Stop';
return;
}
startText.value = '';
stopText.value = '';
if (value === 'Custom') {
stylingMode.value = 'contained';
type.value = state === 'initial' ? 'default' : 'danger';
}
}
</script>
<style>
.speech-to-text-demo {
display: flex;
gap: 20px;
height: 640px;
}
.speech-to-text-container {
display: flex;
flex-direction: column;
row-gap: 16px;
flex-grow: 1;
align-items: center;
justify-content: center;
}
#text-area {
margin-top: 16px;
}
.options {
display: flex;
flex-direction: column;
flex-shrink: 0;
width: 300px;
box-sizing: border-box;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
display: flex;
flex-direction: column;
row-gap: 4px;
}
.switch {
display: flex;
align-items: center;
column-gap: 8px;
}
.option-separator {
border-bottom: 1px solid var(--dx-color-border);
}
.animation-disabled {
animation: none;
}
#speech-to-text.custom-button {
border-radius: 2rem;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const displayModes = ['Icon Only', 'Text and Icon', 'Custom'];
export const stylingModes = [
{
displayValue: 'Contained',
value: 'contained',
},
{
displayValue: 'Outlined',
value: 'outlined',
},
{
displayValue: 'Text',
value: 'text',
},
];
export const types = [
{
displayValue: 'Normal',
value: 'normal',
},
{
displayValue: 'Success',
value: 'success',
},
{
displayValue: 'Default',
value: 'default',
},
{
displayValue: 'Danger',
value: 'danger',
},
];
export const languages = [
'Auto-detect',
'English',
'Spanish',
'French',
'German',
];
export const langMap: Record<string, string> = {
"Auto-detect": '',
"English": 'en-US',
"Spanish": 'es-ES',
"French": 'fr-FR',
"German": 'de-DE',
};
import { createApp } from 'vue';
import themes from 'devextreme/ui/themes';
import App from './App.vue';
themes.initialized(() => createApp(App).mount('#app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

import React, { useCallback, useState } from 'react';
import { SpeechToText } from 'devextreme-react/speech-to-text';
import { TextArea } from 'devextreme-react/text-area';
import { Button } from 'devextreme-react/button';
import type { ButtonTypes } from 'devextreme-react/button';
import { SelectBox } from 'devextreme-react/select-box';
import { Switch } from 'devextreme-react/switch';
import notify from 'devextreme/ui/notify';
import { displayModes, stylingModes, types, languages, langMap } from './data.ts';
import type { Language } from './data.ts';
declare global {
interface Window {
SpeechRecognition: any;
webkitSpeechRecognition: any;
}
}
let state = 'initial';
const textAreaLabel = { 'aria-label': 'Recognized Text' };
const displayModeLabel = { 'aria-label': 'Display Mode' };
const stylingModeLabel = { 'aria-label': 'Styling Mode' };
const typeLabel = { 'aria-label': 'Type' };
const languageLabel = { 'aria-label': 'Language' };
export default function App() {
const [startText, setStartText] = useState<string>('');
const [stopText, setStopText] = useState<string>('');
const [displayMode, setDisplayMode] = useState<string>(displayModes[0]);
const [stylingMode, setStylingMode] = useState<ButtonTypes.ButtonStyle>(stylingModes[0].value);
const [type, setType] = useState<ButtonTypes.ButtonType>(types[2].value);
const [hint, setHint] = useState<string>('Start voice recognition');
const [disabled, setDisabled] = useState<boolean>(false);
const [textAreaValue, setTextAreaValue] = useState<string>('');
const [language, setLanguage] = useState<Language>(languages[0]);
const [interimResults, setInterimResults] = useState<boolean>(true);
const [continuous, setContinuous] = useState<boolean>(false);
const [animation, setAnimation] = useState<boolean>(true);
const speechRecognitionConfig = {
lang: langMap[language],
interimResults,
continuous,
};
const onStartClick = useCallback(() => {
if (!window.SpeechRecognition && !window.webkitSpeechRecognition) {
notify({
message: 'The browser does not support Web Speech API (SpeechRecognition).',
type: 'error',
displayTime: 7000,
position: 'bottom center',
width: 'auto',
});
return;
}
state = 'listening';
setHint('Stop voice recognition');
if (displayMode !== 'Custom') {
return;
}
setType('danger');
}, [displayMode]);
const onEnd = useCallback(() => {
state = 'initial';
setHint('Start voice recognition');
if (displayMode !== 'Custom') {
return;
}
setType('default');
}, [displayMode]);
const onResult = useCallback(({ event }) => {
const { results } = event;
const resultText = Object.values(results)
.map((resultItem: any) => resultItem[0].transcript.trim())
.join(' ');
setTextAreaValue(resultText);
}, []);
const onTextAreaValueChanged = useCallback(({ value }) => {
setTextAreaValue(value);
}, []);
const onClearButtonClick = useCallback(() => {
setTextAreaValue('');
}, []);
const onDisplayModeValueChanged = useCallback(({ value }) => {
setDisplayMode(value);
if (value === 'Text and Icon') {
setStartText('Dictate');
setStopText('Stop');
return;
}
setStartText('');
setStopText('');
if (value === 'Custom') {
setStylingMode('contained');
setType(state === 'initial' ? 'default' : 'danger');
}
}, []);
const onStylingModeValueChanged = useCallback(({ value }) => {
setStylingMode(value);
}, []);
const onTypeValueChanged = useCallback(({ value }) => {
setType(value);
}, []);
const onDisabledValueChanged = useCallback(({ value }) => {
setDisabled(value);
}, []);
const onLanguageValueChanged = useCallback(({ value }) => {
setLanguage(value);
}, []);
const onInterimResultsValueChanged = useCallback(({ value }) => {
setInterimResults(value);
}, []);
const onContinuousValueChanged = useCallback(({ value }) => {
setContinuous(value);
}, []);
const onAnimationValueChanged = useCallback(({ value }) => {
setAnimation(value);
}, []);
return (
<div className='speech-to-text-demo'>
<div className='speech-to-text-container'>
<span>Use voice recognition (speech to text)</span>
<SpeechToText
id='speech-to-text'
className={ `${!animation ? 'animation-disabled' : ''} ${displayMode === 'Custom' ? 'custom-button' : ''}` }
startText={startText}
stopText={stopText}
stylingMode={stylingMode}
type={type}
hint={hint}
speechRecognitionConfig={speechRecognitionConfig}
disabled={disabled}
onStartClick={onStartClick}
onStopClick={onEnd}
onEnd={onEnd}
onResult={onResult}
/>
<TextArea
id='text-area'
value={textAreaValue}
width={360}
height={120}
placeholder='Recognized text will appear here...'
inputAttr={textAreaLabel}
onValueChanged={onTextAreaValueChanged}
/>
<Button
text='Clear'
disabled={textAreaValue === ''}
onClick={onClearButtonClick}
/>
</div>
<div className='options'>
<div className='caption'>Options</div>
<div className='option'>
<div>Display Mode</div>
<SelectBox
value={displayMode}
dataSource={displayModes}
inputAttr={displayModeLabel}
onValueChanged={onDisplayModeValueChanged}
/>
</div>
<div className='option'>
<div>Styling Mode</div>
<SelectBox
value={stylingMode}
dataSource={stylingModes}
valueExpr='value'
displayExpr='displayValue'
disabled={displayMode === 'Custom'}
inputAttr={stylingModeLabel}
onValueChanged={onStylingModeValueChanged}
/>
</div>
<div className='option'>
<div>Type</div>
<SelectBox
value={type}
dataSource={types}
valueExpr='value'
displayExpr='displayValue'
disabled={displayMode === 'Custom'}
inputAttr={typeLabel}
onValueChanged={onTypeValueChanged}
/>
</div>
<div className='switch'>
<Switch value={disabled} onValueChanged={onDisabledValueChanged} />
<span>Disabled</span>
</div>
<div className='option-separator'></div>
<div className='option'>
<div>Language</div>
<SelectBox
value={language}
dataSource={languages}
inputAttr={languageLabel}
onValueChanged={onLanguageValueChanged}
/>
</div>
<div className='switch'>
<Switch
value={interimResults}
onValueChanged={onInterimResultsValueChanged}
/>
<span>Interim Results</span>
</div>
<div className='switch'>
<Switch
value={continuous}
onValueChanged={onContinuousValueChanged}
/>
<span>Continuous Recognition</span>
</div>
<div className='option-separator'></div>
<div className='switch'>
<Switch value={animation} onValueChanged={onAnimationValueChanged} />
<span>Animation</span>
</div>
</div>
</div>
);
}
import React, { useCallback, useState } from 'react';
import { SpeechToText } from 'devextreme-react/speech-to-text';
import { TextArea } from 'devextreme-react/text-area';
import { Button } from 'devextreme-react/button';
import { SelectBox } from 'devextreme-react/select-box';
import { Switch } from 'devextreme-react/switch';
import notify from 'devextreme/ui/notify';
import {
displayModes, stylingModes, types, languages, langMap,
} from './data.js';
let state = 'initial';
const textAreaLabel = { 'aria-label': 'Recognized Text' };
const displayModeLabel = { 'aria-label': 'Display Mode' };
const stylingModeLabel = { 'aria-label': 'Styling Mode' };
const typeLabel = { 'aria-label': 'Type' };
const languageLabel = { 'aria-label': 'Language' };
export default function App() {
const [startText, setStartText] = useState('');
const [stopText, setStopText] = useState('');
const [displayMode, setDisplayMode] = useState(displayModes[0]);
const [stylingMode, setStylingMode] = useState(stylingModes[0].value);
const [type, setType] = useState(types[2].value);
const [hint, setHint] = useState('Start voice recognition');
const [disabled, setDisabled] = useState(false);
const [textAreaValue, setTextAreaValue] = useState('');
const [language, setLanguage] = useState(languages[0]);
const [interimResults, setInterimResults] = useState(true);
const [continuous, setContinuous] = useState(false);
const [animation, setAnimation] = useState(true);
const speechRecognitionConfig = {
lang: langMap[language],
interimResults,
continuous,
};
const onStartClick = useCallback(() => {
if (!window.SpeechRecognition && !window.webkitSpeechRecognition) {
notify({
message: 'The browser does not support Web Speech API (SpeechRecognition).',
type: 'error',
displayTime: 7000,
position: 'bottom center',
width: 'auto',
});
return;
}
state = 'listening';
setHint('Stop voice recognition');
if (displayMode !== 'Custom') {
return;
}
setType('danger');
}, [displayMode]);
const onEnd = useCallback(() => {
state = 'initial';
setHint('Start voice recognition');
if (displayMode !== 'Custom') {
return;
}
setType('default');
}, [displayMode]);
const onResult = useCallback(({ event }) => {
const { results } = event;
const resultText = Object.values(results)
.map((resultItem) => resultItem[0].transcript.trim())
.join(' ');
setTextAreaValue(resultText);
}, []);
const onTextAreaValueChanged = useCallback(({ value }) => {
setTextAreaValue(value);
}, []);
const onClearButtonClick = useCallback(() => {
setTextAreaValue('');
}, []);
const onDisplayModeValueChanged = useCallback(({ value }) => {
setDisplayMode(value);
if (value === 'Text and Icon') {
setStartText('Dictate');
setStopText('Stop');
return;
}
setStartText('');
setStopText('');
if (value === 'Custom') {
setStylingMode('contained');
setType(state === 'initial' ? 'default' : 'danger');
}
}, []);
const onStylingModeValueChanged = useCallback(({ value }) => {
setStylingMode(value);
}, []);
const onTypeValueChanged = useCallback(({ value }) => {
setType(value);
}, []);
const onDisabledValueChanged = useCallback(({ value }) => {
setDisabled(value);
}, []);
const onLanguageValueChanged = useCallback(({ value }) => {
setLanguage(value);
}, []);
const onInterimResultsValueChanged = useCallback(({ value }) => {
setInterimResults(value);
}, []);
const onContinuousValueChanged = useCallback(({ value }) => {
setContinuous(value);
}, []);
const onAnimationValueChanged = useCallback(({ value }) => {
setAnimation(value);
}, []);
return (
<div className="speech-to-text-demo">
<div className="speech-to-text-container">
<span>Use voice recognition (speech to text)</span>
<SpeechToText
id="speech-to-text"
className={`${!animation ? 'animation-disabled' : ''} ${
displayMode === 'Custom' ? 'custom-button' : ''
}`}
startText={startText}
stopText={stopText}
stylingMode={stylingMode}
type={type}
hint={hint}
speechRecognitionConfig={speechRecognitionConfig}
disabled={disabled}
onStartClick={onStartClick}
onStopClick={onEnd}
onEnd={onEnd}
onResult={onResult}
/>
<TextArea
id="text-area"
value={textAreaValue}
width={360}
height={120}
placeholder="Recognized text will appear here..."
inputAttr={textAreaLabel}
onValueChanged={onTextAreaValueChanged}
/>
<Button
text="Clear"
disabled={textAreaValue === ''}
onClick={onClearButtonClick}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<div>Display Mode</div>
<SelectBox
value={displayMode}
dataSource={displayModes}
inputAttr={displayModeLabel}
onValueChanged={onDisplayModeValueChanged}
/>
</div>
<div className="option">
<div>Styling Mode</div>
<SelectBox
value={stylingMode}
dataSource={stylingModes}
valueExpr="value"
displayExpr="displayValue"
disabled={displayMode === 'Custom'}
inputAttr={stylingModeLabel}
onValueChanged={onStylingModeValueChanged}
/>
</div>
<div className="option">
<div>Type</div>
<SelectBox
value={type}
dataSource={types}
valueExpr="value"
displayExpr="displayValue"
disabled={displayMode === 'Custom'}
inputAttr={typeLabel}
onValueChanged={onTypeValueChanged}
/>
</div>
<div className="switch">
<Switch
value={disabled}
onValueChanged={onDisabledValueChanged}
/>
<span>Disabled</span>
</div>
<div className="option-separator"></div>
<div className="option">
<div>Language</div>
<SelectBox
value={language}
dataSource={languages}
inputAttr={languageLabel}
onValueChanged={onLanguageValueChanged}
/>
</div>
<div className="switch">
<Switch
value={interimResults}
onValueChanged={onInterimResultsValueChanged}
/>
<span>Interim Results</span>
</div>
<div className="switch">
<Switch
value={continuous}
onValueChanged={onContinuousValueChanged}
/>
<span>Continuous Recognition</span>
</div>
<div className="option-separator"></div>
<div className="switch">
<Switch
value={animation}
onValueChanged={onAnimationValueChanged}
/>
<span>Animation</span>
</div>
</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import themes from 'devextreme/ui/themes';
import App from './App.tsx';
themes.initialized(() => {
ReactDOM.render(
<App />,
document.getElementById('app'),
);
});
import type { ButtonTypes } from 'devextreme-react/button';
export const displayModes = ['Icon Only', 'Text and Icon', 'Custom'];
export const stylingModes: { displayValue: string; value: ButtonTypes.ButtonStyle }[] = [
{
displayValue: 'Contained',
value: 'contained',
},
{
displayValue: 'Outlined',
value: 'outlined',
},
{
displayValue: 'Text',
value: 'text',
},
];
export const types: { displayValue: string; value: ButtonTypes.ButtonType }[] = [
{
displayValue: 'Normal',
value: 'normal',
},
{
displayValue: 'Success',
value: 'success',
},
{
displayValue: 'Default',
value: 'default',
},
{
displayValue: 'Danger',
value: 'danger',
},
];
export const langMap = {
"Auto-detect": '',
"English": 'en-US',
"Spanish": 'es-ES',
"French": 'fr-FR',
"German": 'de-DE',
};
export type Language = keyof typeof langMap;
export const languages: readonly Language[] = Object.keys(langMap) as Language[];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import themes from 'devextreme/ui/themes';
import App from './App.js';
themes.initialized(() => {
ReactDOM.render(<App />, document.getElementById('app'));
});
export const displayModes = ['Icon Only', 'Text and Icon', 'Custom'];
export const stylingModes = [
{
displayValue: 'Contained',
value: 'contained',
},
{
displayValue: 'Outlined',
value: 'outlined',
},
{
displayValue: 'Text',
value: 'text',
},
];
export const types = [
{
displayValue: 'Normal',
value: 'normal',
},
{
displayValue: 'Success',
value: 'success',
},
{
displayValue: 'Default',
value: 'default',
},
{
displayValue: 'Danger',
value: 'danger',
},
];
export const langMap = {
'Auto-detect': '',
English: 'en-US',
Spanish: 'es-ES',
French: 'fr-FR',
German: 'de-DE',
};
export const languages = Object.keys(langMap);
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.speech-to-text-demo {
display: flex;
gap: 20px;
height: 640px;
}
.speech-to-text-container {
display: flex;
flex-direction: column;
row-gap: 16px;
flex-grow: 1;
align-items: center;
justify-content: center;
}
#text-area {
margin-top: 16px;
}
.options {
display: flex;
flex-direction: column;
flex-shrink: 0;
width: 300px;
box-sizing: border-box;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
display: flex;
flex-direction: column;
row-gap: 4px;
}
.switch {
display: flex;
align-items: center;
column-gap: 8px;
}
.option-separator {
border-bottom: 1px solid var(--dx-color-border);
}
#speech-to-text.animation-disabled {
animation: none;
}
#speech-to-text.custom-button {
border-radius: 2rem;
}

<div class="speech-to-text-demo">
<div class="speech-to-text-container">
<span>Use voice recognition (speech to text)</span>
<dx-speech-to-text
id="speech-to-text"
[class.animation-disabled]="!animation"
[class.custom-button]="displayMode === 'Custom'"
[startText]="startText"
[stopText]="stopText"
[stylingMode]="stylingMode"
[type]="type"
[hint]="hint"
[disabled]="disabled"
[speechRecognitionConfig]="speechRecognitionConfig"
(onStartClick)="onStartClick()"
(onResult)="onResult($event)"
(onEnd)="onEnd()"
></dx-speech-to-text>
<dx-text-area
id="text-area"
[(value)]="textAreaValue"
[width]="360"
[height]="120"
placeholder="Recognized text will appear here..."
[inputAttr]="{ 'aria-label': 'Recognized Text' }"
></dx-text-area>
<dx-button
text="Clear"
[disabled]="textAreaValue === ''"
(onClick)="onClearButtonClick()"
></dx-button>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div>Display Mode</div>
<dx-select-box
[(value)]="displayMode"
[dataSource]="displayModes"
[inputAttr]="{ 'aria-label': 'Display Mode' }"
(onValueChanged)="onDisplayModeChanged($event)"
></dx-select-box>
</div>
<div class="option">
<div>Styling Mode</div>
<dx-select-box
[(value)]="stylingMode"
[dataSource]="stylingModes"
displayExpr="displayValue"
valueExpr="value"
[disabled]="displayMode === 'Custom'"
[inputAttr]="{ 'aria-label': 'Styling Mode' }"
></dx-select-box>
</div>
<div class="option">
<div>Type</div>
<dx-select-box
[(value)]="type"
[dataSource]="types"
displayExpr="displayValue"
valueExpr="value"
[disabled]="displayMode === 'Custom'"
[inputAttr]="{ 'aria-label': 'Type' }"
></dx-select-box>
</div>
<div class="switch">
<dx-switch [(value)]="disabled"></dx-switch>
<span>Disabled</span>
</div>
<div class="option-separator"></div>
<div class="option">
<div>Language</div>
<dx-select-box
[(value)]="language"
[dataSource]="languages"
[inputAttr]="{ 'aria-label': 'Language' }"
(onValueChanged)="updateSpeechRecognitionConfig()"
></dx-select-box>
</div>
<div class="switch">
<dx-switch
[(value)]="interimResults"
(onValueChanged)="updateSpeechRecognitionConfig()"
></dx-switch>
<span>Interim Results</span>
</div>
<div class="switch">
<dx-switch
[(value)]="continuous"
(onValueChanged)="updateSpeechRecognitionConfig()"
></dx-switch>
<span>Continuous Recognition</span>
</div>
<div class="option-separator"></div>
<div class="switch">
<dx-switch [(value)]="animation"></dx-switch>
<span>Animation</span>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxSpeechToTextModule } from 'devextreme-angular/ui/speech-to-text';
import { DxTextAreaModule } from 'devextreme-angular/ui/text-area';
import { DxButtonModule } from 'devextreme-angular/ui/button';
import { DxSelectBoxModule } from 'devextreme-angular/ui/select-box';
import { DxSwitchModule } from 'devextreme-angular/ui/switch';
import notify from 'devextreme/ui/notify';
import { AppService } from './app.service';
declare global {
interface Window {
SpeechRecognition?: any;
webkitSpeechRecognition?: any;
}
}
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxSpeechToTextModule,
DxTextAreaModule,
DxButtonModule,
DxSelectBoxModule,
DxSwitchModule,
],
})
export class AppComponent {
state: 'initial' | 'listening';
startText: string;
stopText: string;
displayMode: string;
displayModes: string[];
stylingMode: string;
stylingModes: { displayValue: string; value: string }[];
type: string;
types: { displayValue: string; value: string }[];
hint: string;
disabled: boolean;
textAreaValue: string;
language: string;
languages: string[];
langMap: { [key: string]: string };
interimResults: boolean;
continuous: boolean;
animation: boolean;
speechRecognitionConfig: Record<string, unknown>;
constructor(private readonly appService: AppService) {
this.state = 'initial';
this.startText = '';
this.stopText = '';
this.displayModes = this.appService.getDisplayModes();
this.displayMode = this.displayModes[0];
this.stylingModes = this.appService.getStylingModes();
this.stylingMode = this.stylingModes[0].value;
this.types = this.appService.getTypes();
this.type = this.types[2].value;
this.hint = 'Start voice recognition';
this.disabled = false;
this.textAreaValue = '';
this.languages = this.appService.getLanguages();
this.language = this.languages[0];
this.langMap = this.appService.getLangMap();
this.interimResults = true;
this.continuous = false;
this.animation = true;
this.updateSpeechRecognitionConfig();
}
onStartClick() {
if (!window.SpeechRecognition && !window.webkitSpeechRecognition) {
notify({
message: 'The browser does not support Web Speech API (SpeechRecognition).',
type: 'error',
displayTime: 7000,
position: 'bottom center',
width: 'auto',
});
return;
}
this.state = 'listening';
this.hint = 'Stop voice recognition';
if (this.displayMode !== 'Custom') {
return;
}
this.type = 'danger';
}
onResult({ event }) {
const { results } = event;
const resultText = Object.values(results)
.map((resultItem) => resultItem[0].transcript.trim())
.join(' ');
this.textAreaValue = resultText;
}
onEnd() {
this.state = 'initial';
this.hint = 'Start voice recognition';
if (this.displayMode !== 'Custom') {
return;
}
this.type = 'default';
}
onClearButtonClick() {
this.textAreaValue = '';
}
onDisplayModeChanged({ value }) {
if (value === 'Text and Icon') {
this.startText = 'Dictate';
this.stopText = 'Stop';
return;
}
this.startText = '';
this.stopText = '';
if (value === 'Custom') {
this.stylingMode = 'contained';
this.type = this.state === 'initial' ? 'default' : 'danger';
}
}
updateSpeechRecognitionConfig() {
this.speechRecognitionConfig = {
lang: this.langMap[this.language],
interimResults: this.interimResults,
continuous: this.continuous,
};
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
AppService,
],
});
::ng-deep .speech-to-text-demo {
display: flex;
gap: 20px;
height: 640px;
}
::ng-deep .speech-to-text-container {
display: flex;
flex-direction: column;
row-gap: 16px;
flex-grow: 1;
align-items: center;
justify-content: center;
}
::ng-deep #text-area {
margin-top: 16px;
}
::ng-deep .options {
display: flex;
flex-direction: column;
flex-shrink: 0;
width: 300px;
box-sizing: border-box;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
}
::ng-deep .caption {
font-weight: 500;
font-size: 18px;
}
::ng-deep .option {
display: flex;
flex-direction: column;
row-gap: 4px;
}
::ng-deep .switch {
display: flex;
align-items: center;
column-gap: 8px;
}
::ng-deep .option-separator {
border-bottom: 1px solid var(--dx-color-border);
}
::ng-deep #speech-to-text.animation-disabled {
animation: none;
}
::ng-deep #speech-to-text.custom-button {
border-radius: 2rem;
}
import { Injectable } from '@angular/core';
import { type DxButtonTypes } from 'devextreme-angular/ui/button';
@Injectable({
providedIn: 'root',
})
export class AppService {
displayModes: string[] = [];
stylingModes: { displayValue: string; value: DxButtonTypes.ButtonStyle }[] = [];
types: { displayValue: string; value: DxButtonTypes.ButtonType }[] = [];
languages: string[] = [];
langMap: { [key: string]: string } = {};
constructor() {
this.displayModes = ['Icon Only', 'Text and Icon', 'Custom'];
this.stylingModes = [
{
displayValue: 'Contained',
value: 'contained',
},
{
displayValue: 'Outlined',
value: 'outlined',
},
{
displayValue: 'Text',
value: 'text',
},
];
this.types = [
{
displayValue: 'Normal',
value: 'normal',
},
{
displayValue: 'Success',
value: 'success',
},
{
displayValue: 'Default',
value: 'default',
},
{
displayValue: 'Danger',
value: 'danger',
},
];
this.languages = [
'Auto-detect',
'English',
'Spanish',
'French',
'German',
];
this.langMap = {
'Auto-detect': '',
'English': 'en-US',
'Spanish': 'es-ES',
'French': 'fr-FR',
'German': 'de-DE',
};
}
getDisplayModes() {
return this.displayModes;
}
getStylingModes() {
return this.stylingModes;
}
getTypes() {
return this.types;
}
getLanguages() {
return this.languages;
}
getLangMap() {
return this.langMap;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>